/*
 * circularBuffer.h
 *
 *  Created on: 07/11/2011
 *      Author: ccortiz
 */

#ifndef CIRCULARBUFFER_H_
#define CIRCULARBUFFER_H_

#define _data char
#define _CIRCULAR_BUFFER_SIZE_ (1024*64)
enum fifoStates{_EMPTY_, _FULL_, _OK_, _OVERWRITTING_};

class circularBuffer {

public:

	circularBuffer();
	virtual ~circularBuffer();
	fifoStates clean();
	fifoStates push(_data newData);
	fifoStates pop(_data* dataPtr);
	unsigned int getNumberOfElements();

	//Experimental
	unsigned int mark;
	void setMark();
	void gotoMark(unsigned int restoredBytes);



private:
	_data dataArray[_CIRCULAR_BUFFER_SIZE_];
	unsigned int nElements;
	unsigned int indexRead;
	unsigned int indexWrite;

};

#endif /* CIRCULARBUFFER_H_ */
