/*
 * mensaje2.h
 *
 *  Created on: 25/05/2012
 *      Author: ccortiz
 */

#ifndef MENSAJE2_H_
#define MENSAJE2_H_

#include "dataTypes.h"
#include "bitStack.h"

typedef int(*getter_Mensaje2_ID_Ptr)(int);
typedef int(*setter_Mensaje2_Repetitions_Ptr)(int, unsigned int);
typedef int(*getter_Mensaje2_Repetitions_Ptr)(int);
typedef int(*setter_Mensaje2_BlockSize_Ptr)(int, unsigned int, unsigned int);
typedef int(*getter_Mensaje2_BlockSize_Ptr)(int, unsigned int);
typedef int(*setter_Mensaje2_Block_Ptr)(int, unsigned int, byte_ptr);
typedef int(*getter_Mensaje2_Block_Ptr)(int, unsigned int, byte_ptr);

typedef struct c_Mensaje2* c_Mensaje2_Ptr;
typedef struct c_Mensaje2_privates* c_Mensaje2_privates_Ptr;


struct c_Mensaje2{
	
	getter_Mensaje2_ID_Ptr get_ID;
	setter_Mensaje2_Repetitions_Ptr set_Repetitions;
	getter_Mensaje2_Repetitions_Ptr get_Repetitions;
	setter_Mensaje2_BlockSize_Ptr set_BlockSize;
	getter_Mensaje2_BlockSize_Ptr get_BlockSize;
	setter_Mensaje2_Block_Ptr set_Block;
	getter_Mensaje2_Block_Ptr get_Block;

	serializerPtr    serialize;
	deserializerPtr  deserialize;
	setEndiannessPtr set_Endianness;
	getMsgSizePtr    get_MsgSize;
};
struct c_Mensaje2_data{
	
	struct{
		uint16 ID;		
		uint16 repetitions;		
	} header;
	
	struct{
		uint16 blockSize;		
		byte block[16];
	} data[5];
};


struct c_Mensaje2_privates{

	int bitStackerDescriptor;
	int msgSize;

	struct c_Mensaje2_data msgInfo;
	struct c_Mensaje2_data msgCheckInfo;
};


void initialize_Mensaje2(int parentDescriptor, c_Mensaje2_Ptr classReference, c_Mensaje2_privates_Ptr privatesReference);
void set_Endianness_Mensaje2(int ICD_Descriptor, enum endianness endianType);

#endif /* MENSAJE2_H_ */

