/*
 * default_ICD.h
 *
 *  Created on: 25/05/2012
 *      Author: ccortiz
 */

#ifndef DEFAULT_ICD_H_
#define DEFAULT_ICD_H_

#define _MAX_ICD_INSTANCES_ 2

#include "mensaje1.h"	
#include "mensaje2.h"	
#include "mensaje3.h"	

#include "bitStack.h"

typedef struct c_DEFAULT_ICD_Privates* c_DEFAULT_ICD_Privates_Ptr;
typedef int (*searchPtr)(int ICD_Descriptor, byte_ptr buffer, unsigned int length);

struct c_DEFAULT_ICD{
	struct c_Mensaje1 mensaje1;
	struct c_Mensaje2 mensaje2;
	struct c_Mensaje3 mensaje3;

	searchPtr		  search;
	setEndiannessPtr  setEndianness;
};


struct c_DEFAULT_ICD_Privates{
	struct c_Mensaje1_privates mensaje1_Privates;
	struct c_Mensaje2_privates mensaje2_Privates;
	struct c_Mensaje3_privates mensaje3_Privates;
};

struct c_DEFAULT_ICD Default_ICD; /* Manejador de ICDs. Solo debe existir uno. */
int new_Default_ICD(void);

/*TODO poner aqui la herramienta de busqueda de mensajes e inicializar el puntero de c_ICD.*/

#endif /*DEFAULT_ICD_H_*/

